// ===========================================================================
// GeoPVR loader
// ===========================================================================

#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <errno.h>
#include <sys/mman.h>
#include <string.h>
#include <inttypes.h>

#include "common.h"

#define MAX_PATH	256

extern void psI_Stream_Record(char *);
extern void psI_Stream_Record_Stop(void);
/* cfgstruct config = DEFAULT_CONFIG; */

static void cacheflush(void *start, size_t size)
{
   // For details, please see the Linux sources, files
   // arch/arm/kernel/traps.c, arch/arm/kernel/entry-common.S and
   // asm-arm/unistd.h

   // This syscall is supported by all 2.4 and 2.6 Linux kernels.  2.2 linux
   // kernels got first support with version 2.2.18.

   asm("mov r0, %0\n"
       "mov r1, %1\n"
       "mov r2, #0\n"
	// EABI or Thumb syscall: syscall number passed in 'r7' (syscall base
	// number is 0x0).  Note that Thumb and EABI are generally not the
	// same.  It just happens that the simple cacheflush syscall doesn't
	// expose any of differences in calling conventions.
       "mov r7, #0xf0000\n"
       "add r7, #0x02\n"
       "swi #0\n" ::
       "g"(start), "g"((long)start+size) :
       "r0", "r1", "r2", "r7");
}

void injector(const char *path)
{
	char s[MAX_PATH];
	int page;

	unsigned *handle=NULL;
	if ( (handle = dlopen(NULL, RTLD_LAZY | RTLD_GLOBAL)) == NULL )
	{
		return;
	}

#if 0
	unsigned *spI_Stream_Record = dlsym(handle, "spI_Stream_Record");
	if (spI_Stream_Record == NULL )
	{
		return;
	}
#endif
	unsigned *KeyCommon_SendKeyPressInput = dlsym(handle, "_ZN9KeyCommon17SendKeyPressInputEii");

	if (KeyCommon_SendKeyPressInput == NULL )
	{
		return;
	}

	dlclose(handle);

	strlcpy(s, path, sizeof(s));
	strlcat(s, "pvr.so", sizeof(s));
	if ( (handle = dlopen(s, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL )
	{
		return;
	}

	void *ex_injection = dlsym(handle, "injection");
	void (*ex_pvr_config)(const char *);
#if 0
	void *ex_pvr_rec_set_test = dlsym(handle, "pvr_rec_set_test");
#endif
	ex_pvr_config = dlsym(handle, "pvr_config");
	dlclose(handle);
 	ex_pvr_config(path);

	// Injecting!
#if 0
	/*
     * This don't needed anymore. Now we have our own
     * pvr_stream_record() instead of bugged spI_Stream_Record().
     */
	page = ((unsigned) spI_Stream_Record) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	spI_Stream_Record[0x11] = 0xE3A00001;	//BL staGetHex -> MOV R0,#01

	/* test spI_Stream_Record() with pvr_rec_set_test() */
 	spI_Stream_Record[0x16] = 0xE59F9008;	//BL printf    -> LDR R9,=ROUTINE (0x8)
	spI_Stream_Record[0x17] = 0xE3A00002;	//BL staGetHex -> MOV R0,#02
	spI_Stream_Record[0x19] = 0xEA000000;	//LDR R0,<str> -> BAL to 0x1B
	spI_Stream_Record[0x1A] =
		(unsigned)ex_pvr_rec_set_test;      //BL printf    -> <LDR address>
	spI_Stream_Record[0x1B] = 0xE3A00003;	//BL staGetHex -> MOV R0,#03
	spI_Stream_Record[0x3F] = 0xE12FFF39;	//BL spIPvr_RecSet -> BLX R9
#if 0
	/* Don't want to test? Use this code then */
	spI_Stream_Record[0x17] = 0xE3A00002;	//BL staGetHex -> MOV R0,#02
	spI_Stream_Record[0x1B] = 0xE3A00003;	//BL staGetHex -> MOV R0,#03
#endif
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);
	cacheflush(spI_Stream_Record+0x11, (0x3F - 0x11) * sizeof(unsigned));
#endif

 	page = ((unsigned) KeyCommon_SendKeyPressInput) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);

	KeyCommon_SendKeyPressInput[4] = 0xE51FF004;
	KeyCommon_SendKeyPressInput[5] = (unsigned)ex_injection;
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);

	cacheflush(KeyCommon_SendKeyPressInput+4, 8);
	// Injection complete!
}

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
	injector(path);
	return 1;
}

