// ===========================================================================
// Common definitions for GeoPVR
// ===========================================================================
#ifndef PVR_H
#define PVR_H

#include "common.h"
#include "timezone.h"
#include "icons.h"
#include "unicode.h"
#include "epg.h"
#include "config.h"
#include "exedsp.h"

/* ===== Key codes ===== */

#define KEY_RECORD	0x49
#define KEY_STOP	0x46
#define KEY_PAUSE	0x4A
#define KEY_FAV_CH	0x44
#define KEY_SOURCE	0x01
#define KEY_POWER	0x02
#define KEY_P_UP	0x12
#define KEY_P_DOWN	0x10
#define KEY_PRE_CH	0x13
#define KEY_NUM0	0x11
#define KEY_NUM1	0x04
#define KEY_NUM2	0x05
#define KEY_NUM3	0x06
#define KEY_NUM4	0x08
#define KEY_NUM5	0x09
#define KEY_NUM6	0x0A
#define KEY_NUM7	0x0C
#define KEY_NUM8	0x0D
#define KEY_NUM9	0x0E
#define KEY_TV		0x1B
#define KEY_CH_LIST	0x6B
#define KEY_CONTENT	0x79
#define KEY_MEDIA_P	0x8C
#define KEY_TTX_MIX	0x2C

/* Input sources */
#define KEY_SOURCE_TV        0x1B
#define KEY_SOURCE_EXT1      0x84
#define KEY_SOURCE_EXT2      0xEB
#define KEY_SOURCE_PC        0x69
#define KEY_SOURCE_AV        0xEC
#define KEY_SOURCE_COMPONENT 0x86
#define KEY_SOURCE_HDMI1     0xE9
#define KEY_SOURCE_HDMI2     0xBE
#define KEY_SOURCE_HDMI3     0xC2 /* HDMI3 / DVI */
#define KEY_SOURCE_HDMI4     0xC5

// key codes: non-existing buttons
#define KEY_ASPECT	0x3E
// key codes: non-existing buttons with unknown functions
#define KEY_DISP_TV	0x7D
#define KEY_DISP_VCR	0x7A
#define KEY_DISP_CABLE	0x7B
// key codes: nothing
#define KEY_NOTHING	0x65	// actually = KEY_LEFT, usually nothing happens

#endif /* PVR_H */
